/**
  ******************************************************************************
  * @file    vk2c22.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vk2c22 functions. 
	*          ļ VK2c22
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vk2c22.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VK2c22_CLK 10 //SCLźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VK2c22ο·
//4com 
//Vk2c22a 
//unsigned char vk2c22_segtab[Vk2c22_SEGNUM]={
//	0,1,2,3,4,5,6,7,8,9,						//SEG0-SEG9
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,22,23,24,25,26,27,28,29,	//SEG20-SEG29
//	30,31,32,33,34,35,36,37,38,39,  //SEG30-SEG39
//	40,41,42,43,									  //SEG40-SEG43
//};
//Vk2c22b 
unsigned char vk2c22_segtab[Vk2c22_SEGNUM]={
	0,1,2,3,4,5,6,7,8,9,						//SEG0-SEG9
	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
	20,21,22,23,24,25,26,27,28,29,	//SEG20-SEG29
	30,31,32,33,34,35,36,37,38,39,  //SEG30-SEG39
};
//LCDʵֻSEG10SEG21ʹ
//.hļVK2c22_SEGNUM=12
//const unsigned char vk2c22_segtab[VK2c22_SEGNUM]={	
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,													//SEG20-SEG21
//};
//vk2c22_dispramӦоƬʾRAM
//4com
unsigned char vk2c22_dispram[Vk2c22_SEGNUM/2];//4COMʱÿֽݶӦ2SEG
//Ӧvk2c22_segtab[VK2c22_SEGNUM]
//ʾRAM bufferΪ8λӦ2SEGbit7/bit3->com3,bit6/bit2->com2,bit5/bit1->com1,bit4/bit0->com0
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
//4COM
vk2c22_dispram[VK2c22_SEGNUM/2]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg4   			vk2c22_dispram[2]-bit3-bit0
	  ,     1C,    1G,      1B,     //seg5				vk2c22_dispram[2]-bit7-bit4
	2D,     2E,    2F,      2A,     //seg6				vk2c22_dispram[3]-bit3-bit0
	  ,     2C,    2G,      2B,     //seg7				vk2c22_dispram[3]-bit7-bit4
	3D,     3E,    3F,      3A,		  //seg8				vk2c22_dispram[4]-bit3-bit0
	  ,     3C,    3G,      3B,			//seg9				vk2c22_dispram[4]-bit7-bit4
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0x5F,0x50,0x3D,0x79,0x72,0x6B,0x6F,0x51,0x7F,0x7B,0x20,0x0E,0x6C,0x76,0x50
};
unsigned char vk2c22_segi,vk2c22_comi;
unsigned char vk2c22_maxcom;//com4com
/* Private function prototypes -----------------------------------------------*/
unsigned char Vk2c22_InitSequence(void);
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : I2CStart
* Description    : ʱ߸ʱɸߵ͵䣬ʾI2Cʼź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_I2CStart( void )
{
  Vk2c22_SCL_H();
  Vk2c22_SDA_H();
  delay_nus(VK2c22_CLK);
  Vk2c22_SDA_L();
  delay_nus(VK2c22_CLK);
}
/*******************************************************************************
* Function Name  : I2CStop
* Description    : ʱ߸ʱɵ͵ߵ䣬ʾI2Cֹͣź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_I2CStop( void )
{
  Vk2c22_SCL_H();
  Vk2c22_SDA_L();
  delay_nus(VK2c22_CLK);
  Vk2c22_SDA_H();
  delay_nus(VK2c22_CLK);
}
/*******************************************************************************
* Function Name  : I2CSlaveAck
* Description    : I2Cӻ豸Ӧѯ
* Input          : None
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Vk2c22_I2CSlaveAck( void )
{
  unsigned int TimeOut;
  unsigned char RetValue;
	
  Vk2c22_SCL_L();
	//ƬSDAΪIOҪΪ
	Vk2c22_SET_SDA_IN();
  delay_nus(VK2c22_CLK);
  Vk2c22_SCL_H();//9sclk

  TimeOut = 10000;
  while( TimeOut-- > 0 )
  {
    if( Vk2c22_GET_SDA()!=0 )//ȡack
    {
      RetValue = 1;
    }
    else
    {
      RetValue = 0;
      break;
    }
  } 
	Vk2c22_SCL_L();
	//ƬSDAΪIOҪΪ
	Vk2c22_SET_SDA_OUT();  
  
  return RetValue;
}
/*******************************************************************************
* Function Name  : I2CWriteByte
* Description    : I2Cдһֽ,͸λ
* Input          : byte-Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_I2CWriteByte( unsigned char byte )
{
	unsigned char i=8;
	while (i--)
	{ 
		Vk2c22_SCL_L();
		if(byte&0x80)
			Vk2c22_SDA_H();
		else
			Vk2c22_SDA_L();
		byte<<=1; 
		delay_nus(VK2c22_CLK);
		Vk2c22_SCL_H();     
		delay_nus(VK2c22_CLK);
	}
}

/*******************************************************************************
* Function Name  : WriteCmd
* Description    : д1ֽ
* Input          : cmd-Ҫд
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char WriteCmdVk2c22(unsigned char cmd)
{
	Vk2c22_I2CStart();

	Vk2c22_I2CWriteByte( Vk2c22_ADDR|0x00 );
	if( 1 == Vk2c22_I2CSlaveAck() )
	{
		Vk2c22_I2CStop(); 
		return 0;   
	}
	Vk2c22_I2CWriteByte( cmd );
	if( 1 == Vk2c22_I2CSlaveAck() )
	{
		Vk2c22_I2CStop(); 
		return 0;   
	}
  Vk2c22_I2CStop();
 
  return 0;    //زɰܱ־
}
/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1ֽݵʾRAM
* Input          : Addr-дramĵַ
*                : Dat->дram
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char Write1DataVk2c22(unsigned char Addr,unsigned char Dat)
{
	//START ź
	Vk2c22_I2CStart(); 
	//SLAVEַ
	Vk2c22_I2CWriteByte(Vk2c22_ADDR); 
	if( 1 == Vk2c22_I2CSlaveAck() )
	{		
		Vk2c22_I2CStop();
		return 1; 
	}
	//ʾRAMַ
	Vk2c22_I2CWriteByte(Addr); 
	if( 1 == Vk2c22_I2CSlaveAck() )
	{
		Vk2c22_I2CStop();
		return 1;
	}
	//ʾݣ1ֽݰ2SEG
	Vk2c22_I2CWriteByte(Dat);
	if( Vk2c22_I2CSlaveAck()==1 )
	{
		Vk2c22_I2CStop();
		return 1;
	}
	//STOPź
 Vk2c22_I2CStop();
 return 0;   
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дݵʾRAM
* Input          : Addr-дramʼַ
*                : Databuf->дrambufferָ
*                : Cnt->дramݸ
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
unsigned char  WritenDataVk2c22(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char n;
	
	//STARTź	
	Vk2c22_I2CStart(); 									
	//SLAVEַ
	Vk2c22_I2CWriteByte(Vk2c22_ADDR); 	
	if( 1 == Vk2c22_I2CSlaveAck() )
	{
		Vk2c22_I2CStop();													
		return 0;										
	}
	//ʾRAMʼַ
	Vk2c22_I2CWriteByte(Addr); 						
	if( 1 == Vk2c22_I2CSlaveAck() )
	{
		Vk2c22_I2CStop();													
		return 0;
	}
	//CntݵʾRAM
	for(n=0;n<Cnt;n++)
	{ 
		Vk2c22_I2CWriteByte(*Databuf++);
		if( Vk2c22_I2CSlaveAck()==1 )
		{
			Vk2c22_I2CStop();													
			return 0;
		}
	}
	//STOPź
	 Vk2c22_I2CStop();											
	 return 0;    
}
/*******************************************************************************
* Function Name  : Vk2c22_DisAll
* Description    : SEGʾͬһݣbit7/bit3-COM3 bit6/bit2-COM2 bit5/bit1-COM1 bit4/bit0-COM0
* 					     : 磺0xffȫ 0x00ȫ 0x55 0xaa 0x33 
* Input          dat->дram(1ֽݶӦ2SEG)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[22];
	
	for(segi=0;segi<28;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVk2c22(0,dispram,22);//8bitݶӦ2SEGÿ8bitݵַ1ÿ8λ1ACK	
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_DisSegComOn(unsigned char seg,unsigned char com)
{
	if(seg%2==0)
		Write1DataVk2c22(seg/2,(1<<(com)));//8λݵ4bitЧÿ8bitݵַ1ÿ8λ1ACK)
	else
		Write1DataVk2c22(seg/2,(1<<(4+com)));//8λݸ4bitЧÿ8bitݵַ1ÿ8λ1ACK	
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_DisSegComOff(unsigned char seg,unsigned char com)
{
	if(seg%2==0)
		Write1DataVk2c22(seg/2,~(1<<com));//8λݵ4bitЧÿ8bitݵַ1ÿ8λ1ACK
	else
		Write1DataVk2c22(seg/2,~(1<<(4+com)));//8λݸ4bitЧÿ8bitݵַ1ÿ8λ1ACK	
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ,ʾ
* Input          None 
* Output         : None
* Return         : 0-ok 1-fail
*******************************************************************************/
void Vk2c22_Enter_Standby(void)
{		
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_2|F_80HZ|RCOFF_LCDOFF);  //ģʽ  1/2 Bais 1/4 Duty֡Ƶ80Hz,ڲϵͳlcdʾ
	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_3|F_80HZ|RCOFF_LCDOFF);  //ģʽ  1/3 Bais 1/4 Duty֡Ƶ80Hz,ڲϵͳlcdʾ
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_2|F_160HZ|RCOFF_LCDOFF); //ģʽ  1/2 Bais 1/4 Duty֡Ƶ160Hz,ڲϵͳlcdʾ
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_3|F_160HZ|RCOFF_LCDOFF); //ģʽ  1/3 Bais 1/4 Duty֡Ƶ?60Hz,ڲϵͳlcdʾ
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_Exit_Standby(void)
{	
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_2|F_80HZ|RCON_LCDON);  //ģʽ  1/2 Bais 1/4 Duty֡Ƶ80Hz,ڲϵͳlcdʾ
	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_3|F_80HZ|RCON_LCDON);  //ģʽ  1/3 Bais 1/4 Duty֡Ƶ80Hz,ڲϵͳlcdʾ
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_2|F_160HZ|RCON_LCDON); //ģʽ  1/2 Bais 1/4 Duty֡Ƶ160Hz,ڲϵͳlcdʾ
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_3|F_160HZ|RCON_LCDON); //ģʽ  1/3 Bais 1/4 Duty֡Ƶ?60Hz,ڲϵͳlcdʾ
}

/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	Vk2c22_SET_SDA_DIR();
	GPIO_SetMode(Vk2c22_SCL_PORT, Vk2c22_SCL_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(Vk2c22_SDA_PORT, Vk2c22_SDA_PIN, GPIO_MODE_QUASI);
		     
	Vk2c22_SCL_H();  
	Vk2c22_SDA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vk2c22_Lowlevel_Init();
	//1/4 Duty
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_2|F_80HZ|RCON_LCDON);  //ģʽ  1/2 Bais 1/4 Duty֡Ƶ80Hz,ڲϵͳlcdʾ
	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_3|F_80HZ|RCON_LCDON);  //ģʽ  1/3 Bais 1/4 Duty֡Ƶ80Hz,ڲϵͳlcdʾ
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_2|F_160HZ|RCON_LCDON); //ģʽ  1/2 Bais 1/4 Duty֡Ƶ160Hz,ڲϵͳlcdʾ
//	WriteCmdVk2c22(Vk2c22_MODESET|BIAS_1_3|F_160HZ|RCON_LCDON); //ģʽ  1/3 Bais 1/4 Duty֡Ƶ?60Hz,ڲϵͳlcdʾ
	vk2c22_maxcom=4;
	WriteCmdVk2c22(Vk2c22_BLINKSET|BLINK_OFF); 		//˸ر	
//	WriteCmdVk2c22(Vk2c22_BLINKSET|BLINK_2HZ); 		//˸2HZ
//	WriteCmdVk2c22(Vk2c22_BLINKSET|BLINK_1HZ); 		//˸1HZ
//	WriteCmdVk2c22(Vk2c22_BLINKSET|BLINK_0D5HZ); 	//˸0.5HZ
	//SEG/VLCDýΪVLCDڲѹܹر,VLCDVDD̽VR=0ƫõѹ=VDD
//	WriteCmdVk2c22(Vk2c22_IVASET|VLCDSEL_IVAOFF_R0); 
	//SEG/VLCDýΪVLCDڲѹܹر,VLCDVDDӵVR>0ƫõѹ=VLCD
//	WriteCmdVk2c22(Vk2c22_IVASET|VLCDSEL_IVAOFF_R1); 
	//SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.652VDD 1/4bias=0.714VDD
	WriteCmdVk2c22(Vk2c22_IVASET|SEGSEL_IVA02H);	 
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
		
	dat8=dat/100%10;	//ʾλ
	vk2c22_dispram[2]&=0xf0;
	vk2c22_dispram[2]|=shuzi_zimo[dat8]&0x0f;
	vk2c22_dispram[2]&=0x8f;
	vk2c22_dispram[2]|=shuzi_zimo[dat8]&0xf0;
	
	dat8=dat/10%10; 	//ʾʮλ
	vk2c22_dispram[3]&=0xf0;
	vk2c22_dispram[3]|=shuzi_zimo[dat8]&0x0f;
	vk2c22_dispram[3]&=0x8f;
	vk2c22_dispram[3]|=shuzi_zimo[dat8]&0xf0;
	
	dat8=dat%10;			//ʾλ
	vk2c22_dispram[4]&=0xf0;
	vk2c22_dispram[4]|=shuzi_zimo[dat8]&0x0f;
	vk2c22_dispram[4]&=0x8f;
	vk2c22_dispram[4]|=shuzi_zimo[dat8]&0xf0;
		
	if(dat<100)				//С100λʾ
	{
	vk2c22_dispram[2]&=0xf0;
	vk2c22_dispram[2]&=0x8f;
	}
	if(dat<10) 	//С10ʮλʾ
	{
	vk2c22_dispram[3]&=0xf0;
	vk2c22_dispram[3]&=0x8f;
	}
	//SEG11
//		Write1DataVk2c22(2,vk2c22_dispram[2]);
//		Write1DataVk2c22(3,vk2c22_dispram[3]);
//		Write1DataVk2c22(4,vk2c22_dispram[4]);
	//SEGͶ
	WritenDataVk2c22(2,&vk2c22_dispram[2],3);	
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk2c22_Main(void)
{	
	Vk2c22_Init();
	Vk2c22_DisAll(0x00);
	while(1)
	{
		Vk2c22_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk2c22_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vk2c22_DisAll(0x00);			//LCDȫ
		for(vk2c22_segi=0;vk2c22_segi<Vk2c22_SEGNUM;vk2c22_segi++)//seg
		{
			for(vk2c22_comi=0;vk2c22_comi<vk2c22_maxcom;vk2c22_comi++)//com
			{
				Vk2c22_DisSegComOn(vk2c22_segtab[vk2c22_segi],vk2c22_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vk2c22_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vk2c22_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vk2c22_segi=0;vk2c22_segi<Vk2c22_SEGNUM;vk2c22_segi++)//seg
		{
			for(vk2c22_comi=0;vk2c22_comi<vk2c22_maxcom;vk2c22_comi++)//com
			{
				Vk2c22_DisSegComOff(vk2c22_segtab[vk2c22_segi],vk2c22_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vk2c22_DisAll(0xff);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vk2c22_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk2c22_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vk2c22_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
